#![allow(dead_code)]
#![allow(non_snake_case)]
#![allow(non_camel_case_types)]
#![allow(non_upper_case_globals)]
#![allow(unused_parens)]
#![allow(unused_imports)]
#![allow(unused_variables)]
#![allow(unused_attributes)]
pub mod Map_ {
    use super::*;
    use crate::module_2031347a::Native_::arrayWithCapacity;
    use crate::module_2031347a::Native_::defaultOf;
    use crate::module_2031347a::Native_::Lrc;
    use crate::module_2031347a::Native_::MutArray;
    use crate::module_2031347a::Native_::MutCell;
    use crate::module_25e675f8::Option_::getValue;
    use crate::module_264daaf9::List_::cons;
    use crate::module_264daaf9::List_::empty as empty_1;
    use crate::module_264daaf9::List_::fold as fold_2;
    use crate::module_264daaf9::List_::head;
    use crate::module_264daaf9::List_::isEmpty as isEmpty_1;
    use crate::module_264daaf9::List_::singleton as singleton_1;
    use crate::module_264daaf9::List_::tail;
    use crate::module_264daaf9::List_::List;
    use crate::module_75c81ae2::Array_::fold as fold_1;
    use crate::module_912d02ed::Interfaces_::IEnumerable_1;
    use crate::module_9d52c5fc::Seq_::compareWith;
    use crate::module_9d52c5fc::Seq_::delay;
    use crate::module_9d52c5fc::Seq_::fold as fold_3;
    use crate::module_9d52c5fc::Seq_::unfold;
    use crate::module_b1128850::Global_::SR::enumerationAlreadyFinished;
    use crate::module_b1128850::Global_::SR::enumerationNotStarted;
    use crate::module_b1128850::Global_::SR::keyNotFound;
    use crate::module_c5a2a64e::String_::string;
    use crate::module_d98fc69f::Util_::compare;
    #[derive(Clone, Debug, Default, Hash)]
    pub struct MapTree_2<K: Clone + 'static, V: Clone + 'static> {
        pub Height: i32,
        pub Key: K,
        pub Value: V,
        pub Left: Map_::Map<K, V>,
        pub Right: Map_::Map<K, V>,
    }
    impl<K: Clone + 'static, V: Clone + 'static> Map_::MapTree_2<K, V> {}
    #[derive(Clone, Debug, Default, Hash)]
    pub struct Map<K: Clone + 'static, V: Clone + 'static> {
        pub root: Option<Lrc<Map_::MapTree_2<K, V>>>,
    }
    impl<K: Clone + 'static, V: Clone + 'static> Map_::Map<K, V> {}
    pub fn mkMap<_a: Clone + 'static, _b: Clone + 'static>(
        root: Option<Lrc<Map_::MapTree_2<_a, _b>>>,
    ) -> Map_::Map<_a, _b> {
        Map_::Map::<_a, _b> { root: root }
    }
    pub fn empty<K: Clone + 'static, V: Clone + 'static>() -> Map_::Map<K, V> {
        Map_::Map::<K, V> {
            root: None::<Lrc<Map_::MapTree_2<K, V>>>,
        }
    }
    pub fn isEmpty<K: Clone + 'static, V: Clone + 'static>(m: Map_::Map<K, V>) -> bool {
        m.root.is_none()
    }
    pub fn mkMapTreeLeaf<K: Clone + 'static, V: Clone + 'static>(k: K, v: V) -> Map_::Map<K, V> {
        Map_::mkMap(Some(Lrc::from(Map_::MapTree_2::<K, V> {
            Height: 1i32,
            Key: k,
            Value: v,
            Left: Map_::empty(),
            Right: Map_::empty(),
        })))
    }
    pub fn mkMapTreeNode<K: Clone + 'static, V: Clone + 'static>(
        k: K,
        v: V,
        left: Map_::Map<K, V>,
        right: Map_::Map<K, V>,
        h: i32,
    ) -> Map_::Map<K, V> {
        Map_::mkMap(Some(Lrc::from(Map_::MapTree_2::<K, V> {
            Height: h,
            Key: k,
            Value: v,
            Left: left,
            Right: right,
        })))
    }
    pub fn singleton<K: Clone + 'static, V: Clone + 'static>(k: K, v: V) -> Map_::Map<K, V> {
        Map_::mkMapTreeLeaf(k, v)
    }
    pub fn sizeAux<K: Clone + 'static, V: Clone + 'static>(acc: i32, m: Map_::Map<K, V>) -> i32 {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    acc + 1i32
                } else {
                    Map_::sizeAux(Map_::sizeAux(acc + 1i32, t.Left.clone()), t.Right.clone())
                }
            }
            _ => acc,
        }
    }
    pub fn count<_a: Clone + 'static, _b: Clone + 'static>(x: Map_::Map<_a, _b>) -> i32 {
        Map_::sizeAux(0i32, x)
    }
    pub fn height<K: Clone + 'static, V: Clone + 'static>(m: Map_::Map<K, V>) -> i32 {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => matchValue_0_0.Height,
            _ => 0i32,
        }
    }
    pub fn mk<K: Clone + 'static, V: Clone + 'static>(
        l: Map_::Map<K, V>,
        k: K,
        v: V,
        r: Map_::Map<K, V>,
    ) -> Map_::Map<K, V> {
        let hl: i32 = {
            let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = l.root.clone();
            match &matchValue {
                Some(matchValue_0_0) => matchValue_0_0.Height,
                _ => 0i32,
            }
        };
        let hr: i32 = {
            let matchValue_1: Option<Lrc<Map_::MapTree_2<K, V>>> = r.root.clone();
            match &matchValue_1 {
                Some(matchValue_1_0_0) => matchValue_1_0_0.Height,
                _ => 0i32,
            }
        };
        let m_5: i32 = if hl < hr { hr } else { hl };
        if m_5 == 0i32 {
            Map_::mkMapTreeLeaf(k.clone(), v.clone())
        } else {
            Map_::mkMapTreeNode(k, v, l, r, m_5 + 1i32)
        }
    }
    pub fn rebalance<K: Clone + 'static, V: Clone + 'static>(
        t1: Map_::Map<K, V>,
        k: K,
        v: V,
        t2: Map_::Map<K, V>,
    ) -> Map_::Map<K, V> {
        let t1h: i32 = {
            let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = t1.root.clone();
            match &matchValue {
                Some(matchValue_0_0) => matchValue_0_0.Height,
                _ => 0i32,
            }
        };
        let t2h: i32 = {
            let matchValue_1: Option<Lrc<Map_::MapTree_2<K, V>>> = t2.root.clone();
            match &matchValue_1 {
                Some(matchValue_1_0_0) => matchValue_1_0_0.Height,
                _ => 0i32,
            }
        };
        if t2h > t1h + 2i32 {
            let t2_: Lrc<Map_::MapTree_2<K, V>> = getValue(t2.root.clone()).clone();
            if {
                let matchValue_2: Option<Lrc<Map_::MapTree_2<K, V>>> = t2_.Left.root.clone();
                match &matchValue_2 {
                    Some(matchValue_2_0_0) => matchValue_2_0_0.Height,
                    _ => 0i32,
                }
            } > t1h + 1i32
            {
                let t2l: Lrc<Map_::MapTree_2<K, V>> = getValue(t2_.Left.root.clone()).clone();
                Map_::mk(
                    Map_::mk(t1.clone(), k.clone(), v.clone(), t2l.Left.clone()),
                    t2l.Key.clone(),
                    t2l.Value.clone(),
                    Map_::mk(
                        t2l.Right.clone(),
                        t2_.Key.clone(),
                        t2_.Value.clone(),
                        t2_.Right.clone(),
                    ),
                )
            } else {
                Map_::mk(
                    Map_::mk(t1.clone(), k.clone(), v.clone(), t2_.Left.clone()),
                    t2_.Key.clone(),
                    t2_.Value.clone(),
                    t2_.Right.clone(),
                )
            }
        } else {
            if t1h > t2h + 2i32 {
                let t1_: Lrc<Map_::MapTree_2<K, V>> = getValue(t1.root.clone()).clone();
                if {
                    let matchValue_3: Option<Lrc<Map_::MapTree_2<K, V>>> = t1_.Right.root.clone();
                    match &matchValue_3 {
                        Some(matchValue_3_0_0) => matchValue_3_0_0.Height,
                        _ => 0i32,
                    }
                } > t2h + 1i32
                {
                    let t1r: Lrc<Map_::MapTree_2<K, V>> = getValue(t1_.Right.root.clone()).clone();
                    Map_::mk(
                        Map_::mk(
                            t1_.Left.clone(),
                            t1_.Key.clone(),
                            t1_.Value.clone(),
                            t1r.Left.clone(),
                        ),
                        t1r.Key.clone(),
                        t1r.Value.clone(),
                        Map_::mk(t1r.Right.clone(), k.clone(), v.clone(), t2.clone()),
                    )
                } else {
                    Map_::mk(
                        t1_.Left.clone(),
                        t1_.Key.clone(),
                        t1_.Value.clone(),
                        Map_::mk(t1_.Right.clone(), k.clone(), v.clone(), t2.clone()),
                    )
                }
            } else {
                Map_::mk(t1, k, v, t2)
            }
        }
    }
    pub fn add<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        v: V,
        m: Map_::Map<K, V>,
    ) -> Map_::Map<K, V> {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                let c: i32 = compare(k.clone(), t.Key.clone());
                if t.Height == 1i32 {
                    if c < 0i32 {
                        Map_::mkMapTreeNode(k.clone(), v.clone(), Map_::empty(), m.clone(), 2i32)
                    } else {
                        if c == 0i32 {
                            Map_::mkMapTreeLeaf(k.clone(), v.clone())
                        } else {
                            Map_::mkMapTreeNode(k.clone(), v.clone(), m, Map_::empty(), 2i32)
                        }
                    }
                } else {
                    if c < 0i32 {
                        Map_::rebalance(
                            Map_::add(k.clone(), v.clone(), t.Left.clone()),
                            t.Key.clone(),
                            t.Value.clone(),
                            t.Right.clone(),
                        )
                    } else {
                        if c == 0i32 {
                            Map_::mkMapTreeNode(
                                k.clone(),
                                v.clone(),
                                t.Left.clone(),
                                t.Right.clone(),
                                t.Height,
                            )
                        } else {
                            Map_::rebalance(
                                t.Left.clone(),
                                t.Key.clone(),
                                t.Value.clone(),
                                Map_::add(k.clone(), v.clone(), t.Right.clone()),
                            )
                        }
                    }
                }
            }
            _ => Map_::mkMapTreeLeaf(k, v),
        }
    }
    pub fn tryGetValue<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        v: &Lrc<MutCell<V>>,
        m: Map_::Map<K, V>,
    ) -> bool {
        let k: Lrc<MutCell<K>> = Lrc::from(MutCell::from(k.clone()));
        let m: Lrc<MutCell<Map_::Map<K, V>>> = Lrc::from(MutCell::from(m));
        '_tryGetValue: loop {
            break '_tryGetValue ({
                let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
                match &matchValue {
                    Some(matchValue_0_0) => {
                        let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                        let c: i32 = compare(k.get(), t.Key.clone());
                        if c == 0i32 {
                            v.set(t.Value.clone());
                            true
                        } else {
                            if t.Height == 1i32 {
                                false
                            } else {
                                let k_temp: K = k.get();
                                let v_temp: V = v.get().clone();
                                let m_temp: Map_::Map<K, V> = if c < 0i32 {
                                    t.Left.clone()
                                } else {
                                    t.Right.clone()
                                };
                                k.set(k_temp);
                                v.set(v_temp);
                                m.set(m_temp);
                                continue '_tryGetValue;
                            }
                        }
                    }
                    _ => false,
                }
            });
        }
    }
    pub fn throwKeyNotFound<_a: Clone + 'static>() -> _a {
        panic!("{}", keyNotFound())
    }
    pub fn find<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        m: Map_::Map<K, V>,
    ) -> V {
        let v: Lrc<MutCell<V>> = Lrc::from(MutCell::from(defaultOf::<V>()));
        if Map_::tryGetValue(k, &v, m) {
            v.get()
        } else {
            Map_::throwKeyNotFound()
        }
    }
    pub fn tryFind<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        m: Map_::Map<K, V>,
    ) -> Option<V> {
        let v: Lrc<MutCell<V>> = Lrc::from(MutCell::from(defaultOf::<V>()));
        if Map_::tryGetValue(k, &v, m) {
            Some(v.get())
        } else {
            None::<V>
        }
    }
    pub fn item<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        m: Map_::Map<K, V>,
    ) -> V {
        Map_::find(k, m)
    }
    pub fn partition1<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        f: Lrc<impl Fn(_a, _b) -> (bool) + 'static>,
        k: _a,
        v: _b,
        acc1: Map_::Map<_a, _b>,
        acc2: Map_::Map<_a, _b>,
    ) -> Lrc<(Map_::Map<_a, _b>, Map_::Map<_a, _b>)> {
        if f(k.clone(), v.clone()) {
            Lrc::from((Map_::add(k.clone(), v.clone(), acc1.clone()), acc2.clone()))
        } else {
            Lrc::from((acc1, Map_::add(k, v, acc2)))
        }
    }
    pub fn partitionAux<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        f: Lrc<impl Fn(K, V) -> (bool) + 'static>,
        m: Map_::Map<K, V>,
        acc_: Map_::Map<K, V>,
        acc__1: Map_::Map<K, V>,
    ) -> Lrc<(Map_::Map<K, V>, Map_::Map<K, V>)> {
        let acc: Lrc<(Map_::Map<K, V>, Map_::Map<K, V>)> = Lrc::from((acc_, acc__1));
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    Map_::partition1(
                        f.clone(),
                        t.Key.clone(),
                        t.Value.clone(),
                        acc.0.clone(),
                        acc.1.clone(),
                    )
                } else {
                    let acc_3: Lrc<(Map_::Map<K, V>, Map_::Map<K, V>)> = Map_::partitionAux(
                        f.clone(),
                        t.Right.clone(),
                        acc.0.clone(),
                        acc.1.clone(),
                    );
                    let acc_6: Lrc<(Map_::Map<K, V>, Map_::Map<K, V>)> = Map_::partition1(
                        f.clone(),
                        t.Key.clone(),
                        t.Value.clone(),
                        acc_3.0.clone(),
                        acc_3.1.clone(),
                    );
                    Map_::partitionAux(f, t.Left.clone(), acc_6.0.clone(), acc_6.1.clone())
                }
            }
            _ => acc,
        }
    }
    pub fn partition<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        f: Lrc<impl Fn(_a, _b) -> (bool) + 'static>,
        m: Map_::Map<_a, _b>,
    ) -> Lrc<(Map_::Map<_a, _b>, Map_::Map<_a, _b>)> {
        Map_::partitionAux(f, m, Map_::empty(), Map_::empty())
    }
    pub fn filter1<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        f: Lrc<impl Fn(_a, _b) -> (bool) + 'static>,
        k: _a,
        v: _b,
        acc: Map_::Map<_a, _b>,
    ) -> Map_::Map<_a, _b> {
        if f(k.clone(), v.clone()) {
            Map_::add(k, v, acc.clone())
        } else {
            acc
        }
    }
    pub fn filterAux<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        f: Lrc<impl Fn(K, V) -> (bool) + 'static>,
        m: Map_::Map<K, V>,
        acc: Map_::Map<K, V>,
    ) -> Map_::Map<K, V> {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    Map_::filter1(f.clone(), t.Key.clone(), t.Value.clone(), acc.clone())
                } else {
                    Map_::filterAux(
                        f.clone(),
                        t.Right.clone(),
                        Map_::filter1(
                            f.clone(),
                            t.Key.clone(),
                            t.Value.clone(),
                            Map_::filterAux(f, t.Left.clone(), acc.clone()),
                        ),
                    )
                }
            }
            _ => acc,
        }
    }
    pub fn filter<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        f: Lrc<impl Fn(_a, _b) -> (bool) + 'static>,
        m: Map_::Map<_a, _b>,
    ) -> Map_::Map<_a, _b> {
        Map_::filterAux(f, m, Map_::empty())
    }
    pub fn spliceOutSuccessor<K: Clone + 'static, V: Clone + 'static>(
        m: Map_::Map<K, V>,
    ) -> Lrc<(K, V, Map_::Map<K, V>)> {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    Lrc::from((t.Key.clone(), t.Value.clone(), Map_::empty()))
                } else {
                    if Map_::isEmpty(t.Left.clone()) {
                        Lrc::from((t.Key.clone(), t.Value.clone(), t.Right.clone()))
                    } else {
                        let patternInput: Lrc<(K, V, Map_::Map<K, V>)> =
                            Map_::spliceOutSuccessor(t.Left.clone());
                        Lrc::from((
                            patternInput.0.clone(),
                            patternInput.1.clone(),
                            Map_::mk(
                                patternInput.2.clone(),
                                t.Key.clone(),
                                t.Value.clone(),
                                t.Right.clone(),
                            ),
                        ))
                    }
                }
            }
            _ => panic!("{}", string("internal error: Map.spliceOutSuccessor")),
        }
    }
    pub fn remove<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        m: Map_::Map<K, V>,
    ) -> Map_::Map<K, V> {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                let c: i32 = compare(k.clone(), t.Key.clone());
                if t.Height == 1i32 {
                    if c == 0i32 {
                        Map_::empty()
                    } else {
                        m
                    }
                } else {
                    if c < 0i32 {
                        Map_::rebalance(
                            Map_::remove(k.clone(), t.Left.clone()),
                            t.Key.clone(),
                            t.Value.clone(),
                            t.Right.clone(),
                        )
                    } else {
                        if c == 0i32 {
                            if Map_::isEmpty(t.Left.clone()) {
                                t.Right.clone()
                            } else {
                                if Map_::isEmpty(t.Right.clone()) {
                                    t.Left.clone()
                                } else {
                                    let patternInput: Lrc<(K, V, Map_::Map<K, V>)> =
                                        Map_::spliceOutSuccessor(t.Right.clone());
                                    Map_::mk(
                                        t.Left.clone(),
                                        patternInput.0.clone(),
                                        patternInput.1.clone(),
                                        patternInput.2.clone(),
                                    )
                                }
                            }
                        } else {
                            Map_::rebalance(
                                t.Left.clone(),
                                t.Key.clone(),
                                t.Value.clone(),
                                Map_::remove(k, t.Right.clone()),
                            )
                        }
                    }
                }
            }
            _ => Map_::empty(),
        }
    }
    pub fn change<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        u: Lrc<impl Fn(Option<V>) -> (Option<V>) + 'static>,
        m: Map_::Map<K, V>,
    ) -> Map_::Map<K, V> {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    let c: i32 = compare(k.clone(), t.Key.clone());
                    if c < 0i32 {
                        let matchValue_2: Option<V> = u(None::<V>);
                        match &matchValue_2 {
                            Some(matchValue_2_0_0) => Map_::mkMapTreeNode(
                                k.clone(),
                                matchValue_2_0_0.clone(),
                                Map_::empty(),
                                m.clone(),
                                2i32,
                            ),
                            _ => m.clone(),
                        }
                    } else {
                        if c == 0i32 {
                            let matchValue_3: Option<V> = u(Some(t.Value.clone()));
                            match &matchValue_3 {
                                Some(matchValue_3_0_0) => {
                                    Map_::mkMapTreeLeaf(k.clone(), matchValue_3_0_0.clone())
                                }
                                _ => Map_::empty(),
                            }
                        } else {
                            let matchValue_4: Option<V> = u(None::<V>);
                            match &matchValue_4 {
                                Some(matchValue_4_0_0) => Map_::mkMapTreeNode(
                                    k.clone(),
                                    matchValue_4_0_0.clone(),
                                    m.clone(),
                                    Map_::empty(),
                                    2i32,
                                ),
                                _ => m.clone(),
                            }
                        }
                    }
                } else {
                    let c_1: i32 = compare(k.clone(), t.Key.clone());
                    if c_1 < 0i32 {
                        Map_::rebalance(
                            Map_::change(k.clone(), u.clone(), t.Left.clone()),
                            t.Key.clone(),
                            t.Value.clone(),
                            t.Right.clone(),
                        )
                    } else {
                        if c_1 == 0i32 {
                            let matchValue_5: Option<V> = u(Some(t.Value.clone()));
                            match &matchValue_5 {
                                Some(matchValue_5_0_0) => Map_::mkMapTreeNode(
                                    k.clone(),
                                    matchValue_5_0_0.clone(),
                                    t.Left.clone(),
                                    t.Right.clone(),
                                    t.Height,
                                ),
                                _ => {
                                    if Map_::isEmpty(t.Left.clone()) {
                                        t.Right.clone()
                                    } else {
                                        if Map_::isEmpty(t.Right.clone()) {
                                            t.Left.clone()
                                        } else {
                                            let patternInput: Lrc<(K, V, Map_::Map<K, V>)> =
                                                Map_::spliceOutSuccessor(t.Right.clone());
                                            Map_::mk(
                                                t.Left.clone(),
                                                patternInput.0.clone(),
                                                patternInput.1.clone(),
                                                patternInput.2.clone(),
                                            )
                                        }
                                    }
                                }
                            }
                        } else {
                            Map_::rebalance(
                                t.Left.clone(),
                                t.Key.clone(),
                                t.Value.clone(),
                                Map_::change(k.clone(), u.clone(), t.Right.clone()),
                            )
                        }
                    }
                }
            }
            _ => {
                let matchValue_1: Option<V> = u(None::<V>);
                match &matchValue_1 {
                    Some(matchValue_1_0_0) => Map_::mkMapTreeLeaf(k, matchValue_1_0_0.clone()),
                    _ => m,
                }
            }
        }
    }
    pub fn containsKey<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        k: K,
        m: Map_::Map<K, V>,
    ) -> bool {
        let k: Lrc<MutCell<K>> = Lrc::from(MutCell::from(k.clone()));
        let m: Lrc<MutCell<Map_::Map<K, V>>> = Lrc::from(MutCell::from(m));
        '_containsKey: loop {
            break '_containsKey ({
                let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
                match &matchValue {
                    Some(matchValue_0_0) => {
                        let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                        let c: i32 = compare(k.get(), t.Key.clone());
                        if t.Height == 1i32 {
                            c == 0i32
                        } else {
                            if c < 0i32 {
                                let k_temp: K = k.get();
                                let m_temp: Map_::Map<K, V> = t.Left.clone();
                                k.set(k_temp);
                                m.set(m_temp);
                                continue '_containsKey;
                            } else {
                                if c == 0i32 {
                                    true
                                } else {
                                    let k_temp: K = k.get();
                                    let m_temp: Map_::Map<K, V> = t.Right.clone();
                                    k.set(k_temp);
                                    m.set(m_temp);
                                    continue '_containsKey;
                                }
                            }
                        }
                    }
                    _ => false,
                }
            });
        }
    }
    pub fn iterate<K: Clone + 'static, V: Clone + 'static>(
        f: Lrc<impl Fn(K, V) + 'static>,
        m: Map_::Map<K, V>,
    ) {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone(), t.Value.clone())
                } else {
                    Map_::iterate(f.clone(), t.Left.clone());
                    f(t.Key.clone(), t.Value.clone());
                    Map_::iterate(f, t.Right.clone())
                }
            }
            _ => (),
        }
    }
    pub fn tryPick<K: Clone + 'static, V: Clone + 'static, _a: Clone + 'static>(
        f: Lrc<impl Fn(K, V) -> (Option<_a>) + 'static>,
        m: Map_::Map<K, V>,
    ) -> Option<_a> {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone(), t.Value.clone())
                } else {
                    let matchValue_1: Option<_a> = Map_::tryPick(f.clone(), t.Left.clone());
                    match &matchValue_1 {
                        None => {
                            let matchValue_2: Option<_a> = f(t.Key.clone(), t.Value.clone());
                            match &matchValue_2 {
                                None => Map_::tryPick(f, t.Right.clone()),
                                _ => matchValue_2.clone(),
                            }
                        }
                        _ => matchValue_1.clone(),
                    }
                }
            }
            _ => None::<_a>,
        }
    }
    pub fn pick<K: Clone + 'static, V: Clone + 'static, _a: Clone + 'static>(
        chooser: Lrc<impl Fn(K, V) -> (Option<_a>) + 'static>,
        m: Map_::Map<K, V>,
    ) -> _a {
        let matchValue: Option<_a> = Map_::tryPick(chooser, m);
        match &matchValue {
            Some(matchValue_0_0) => matchValue_0_0.clone(),
            _ => Map_::throwKeyNotFound(),
        }
    }
    pub fn findKey<K: Clone + 'static, V: Clone + 'static>(
        predicate: Lrc<impl Fn(K, V) -> (bool) + 'static>,
        m: Map_::Map<K, V>,
    ) -> K {
        Map_::pick(
            Lrc::from({
                let predicate = predicate.clone();
                move |k: K, v: V| {
                    if predicate(k.clone(), v.clone()) {
                        Some(k.clone())
                    } else {
                        None::<K>
                    }
                }
            }),
            m,
        )
    }
    pub fn tryFindKey<K: Clone + 'static, V: Clone + 'static>(
        predicate: Lrc<impl Fn(K, V) -> (bool) + 'static>,
        m: Map_::Map<K, V>,
    ) -> Option<K> {
        Map_::tryPick(
            Lrc::from({
                let predicate = predicate.clone();
                move |k: K, v: V| {
                    if predicate(k.clone(), v.clone()) {
                        Some(k.clone())
                    } else {
                        None::<K>
                    }
                }
            }),
            m,
        )
    }
    pub fn exists<K: Clone + 'static, V: Clone + 'static>(
        f: Lrc<impl Fn(K, V) -> (bool) + 'static>,
        m: Map_::Map<K, V>,
    ) -> bool {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone(), t.Value.clone())
                } else {
                    if if Map_::exists(f.clone(), t.Left.clone()) {
                        true
                    } else {
                        f(t.Key.clone(), t.Value.clone())
                    } {
                        true
                    } else {
                        Map_::exists(f, t.Right.clone())
                    }
                }
            }
            _ => false,
        }
    }
    pub fn forAll<K: Clone + 'static, V: Clone + 'static>(
        f: Lrc<impl Fn(K, V) -> (bool) + 'static>,
        m: Map_::Map<K, V>,
    ) -> bool {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone(), t.Value.clone())
                } else {
                    if if Map_::forAll(f.clone(), t.Left.clone()) {
                        f(t.Key.clone(), t.Value.clone())
                    } else {
                        false
                    } {
                        Map_::forAll(f, t.Right.clone())
                    } else {
                        false
                    }
                }
            }
            _ => true,
        }
    }
    pub fn mapRange<V: Clone + 'static, R: Clone + 'static, K: Clone + 'static>(
        f: Lrc<impl Fn(V) -> (R) + 'static>,
        m: Map_::Map<K, V>,
    ) -> Map_::Map<K, R> {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    Map_::mkMapTreeLeaf(t.Key.clone(), f(t.Value.clone()))
                } else {
                    let l2: Map_::Map<K, R> = Map_::mapRange(f.clone(), t.Left.clone());
                    Map_::mkMapTreeNode(
                        t.Key.clone(),
                        f(t.Value.clone()),
                        l2,
                        Map_::mapRange(f, t.Right.clone()),
                        t.Height,
                    )
                }
            }
            _ => Map_::empty(),
        }
    }
    pub fn map<K: Clone + 'static, V: Clone + 'static, R: Clone + 'static>(
        f: Lrc<impl Fn(K, V) -> (R) + 'static>,
        m: Map_::Map<K, V>,
    ) -> Map_::Map<K, R> {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    Map_::mkMapTreeLeaf(t.Key.clone(), f(t.Key.clone(), t.Value.clone()))
                } else {
                    let l2: Map_::Map<K, R> = Map_::map(f.clone(), t.Left.clone());
                    Map_::mkMapTreeNode(
                        t.Key.clone(),
                        f(t.Key.clone(), t.Value.clone()),
                        l2,
                        Map_::map(f, t.Right.clone()),
                        t.Height,
                    )
                }
            }
            _ => Map_::empty(),
        }
    }
    pub fn foldBack<K: Clone + 'static, V: Clone + 'static, _a: Clone + 'static>(
        f: Lrc<impl Fn(K, V, _a) -> (_a) + 'static>,
        m: Map_::Map<K, V>,
        x: _a,
    ) -> _a {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    f(t.Key.clone(), t.Value.clone(), x.clone())
                } else {
                    Map_::foldBack(
                        f.clone(),
                        t.Left.clone(),
                        f(
                            t.Key.clone(),
                            t.Value.clone(),
                            Map_::foldBack(f.clone(), t.Right.clone(), x.clone()),
                        ),
                    )
                }
            }
            _ => x,
        }
    }
    pub fn fold<_a: Clone + 'static, K: Clone + 'static, V: Clone + 'static>(
        f: Lrc<impl Fn(_a, K, V) -> (_a) + 'static>,
        x: _a,
        m: Map_::Map<K, V>,
    ) -> _a {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    f(x.clone(), t.Key.clone(), t.Value.clone())
                } else {
                    Map_::fold(
                        f.clone(),
                        f(
                            Map_::fold(f.clone(), x.clone(), t.Left.clone()),
                            t.Key.clone(),
                            t.Value.clone(),
                        ),
                        t.Right.clone(),
                    )
                }
            }
            _ => x,
        }
    }
    pub fn foldFromTo<K: PartialOrd + Clone + 'static, V: Clone + 'static, _a: Clone + 'static>(
        lo: K,
        hi: K,
        f: Lrc<impl Fn(K, V, _a) -> (_a) + 'static>,
        m: Map_::Map<K, V>,
        x: _a,
    ) -> _a {
        let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = m.root.clone();
        match &matchValue {
            Some(matchValue_0_0) => {
                let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                if t.Height == 1i32 {
                    if if compare(lo.clone(), t.Key.clone()) <= 0i32 {
                        compare(t.Key.clone(), hi.clone()) <= 0i32
                    } else {
                        false
                    } {
                        f(t.Key.clone(), t.Value.clone(), x.clone())
                    } else {
                        x.clone()
                    }
                } else {
                    let cLoKey_1: i32 = compare(lo.clone(), t.Key.clone());
                    let cKeyHi_1: i32 = compare(t.Key.clone(), hi.clone());
                    let x_2: _a = if cLoKey_1 < 0i32 {
                        Map_::foldFromTo(
                            lo.clone(),
                            hi.clone(),
                            f.clone(),
                            t.Left.clone(),
                            x.clone(),
                        )
                    } else {
                        x.clone()
                    };
                    let x_3: _a = if if cLoKey_1 <= 0i32 {
                        cKeyHi_1 <= 0i32
                    } else {
                        false
                    } {
                        f(t.Key.clone(), t.Value.clone(), x_2.clone())
                    } else {
                        x_2
                    };
                    if cKeyHi_1 < 0i32 {
                        Map_::foldFromTo(lo, hi, f, t.Right.clone(), x_3.clone())
                    } else {
                        x_3
                    }
                }
            }
            _ => x,
        }
    }
    pub fn foldSection<K: PartialOrd + Clone + 'static, V: Clone + 'static, _a: Clone + 'static>(
        lo: K,
        hi: K,
        f: Lrc<impl Fn(K, V, _a) -> (_a) + 'static>,
        m: Map_::Map<K, V>,
        x: _a,
    ) -> _a {
        if compare(lo.clone(), hi.clone()) == 1i32 {
            x.clone()
        } else {
            Map_::foldFromTo(lo, hi, f, m, x)
        }
    }
    pub fn copyToArray<_a: Clone + 'static, _b: Clone + 'static>(
        m: Map_::Map<_a, _b>,
        arr: Lrc<MutArray<Lrc<(_a, _b)>>>,
        i: i32,
    ) {
        let j: Lrc<MutCell<i32>> = Lrc::from(MutCell::from(i));
        Map_::iterate(
            Lrc::from({
                let arr = arr.clone();
                let j = j.clone();
                move |k: _a, v: _b| {
                    arr.get_mut()[j.get() as usize] = Lrc::from((k.clone(), v.clone()));
                    j.set(j.get() + 1i32)
                }
            }),
            m,
        )
    }
    pub fn keys<K: Clone + 'static, V: Clone + 'static>(m: Map_::Map<K, V>) -> Lrc<MutArray<K>> {
        let res: Lrc<MutArray<K>> = arrayWithCapacity::<K>(Map_::count(m.clone()));
        Map_::iterate(
            Lrc::from({
                let res = res.clone();
                move |k: K, v: V| res.get_mut().push(k.clone())
            }),
            m,
        );
        res.clone()
    }
    pub fn values<K: Clone + 'static, V: Clone + 'static>(m: Map_::Map<K, V>) -> Lrc<MutArray<V>> {
        let res: Lrc<MutArray<V>> = arrayWithCapacity::<V>(Map_::count(m.clone()));
        Map_::iterate(
            Lrc::from({
                let res = res.clone();
                move |k: K, v: V| res.get_mut().push(v.clone())
            }),
            m,
        );
        res.clone()
    }
    pub fn toArray<K: Clone + 'static, V: Clone + 'static>(
        m: Map_::Map<K, V>,
    ) -> Lrc<MutArray<Lrc<(K, V)>>> {
        let res: Lrc<MutArray<Lrc<(K, V)>>> =
            arrayWithCapacity::<Lrc<(K, V)>>(Map_::count(m.clone()));
        Map_::iterate(
            Lrc::from({
                let res = res.clone();
                move |k: K, v: V| res.get_mut().push(Lrc::from((k.clone(), v.clone())))
            }),
            m,
        );
        res.clone()
    }
    pub fn toList<K: Clone + 'static, V: Clone + 'static>(m: Map_::Map<K, V>) -> List<Lrc<(K, V)>> {
        Map_::foldBack(
            Lrc::from(move |k: K, v: V, acc: List<Lrc<(K, V)>>| {
                cons(Lrc::from((k.clone(), v.clone())), acc.clone())
            }),
            m,
            empty_1::<Lrc<(K, V)>>(),
        )
    }
    pub fn ofArray<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        xs: Lrc<MutArray<Lrc<(_a, _b)>>>,
    ) -> Map_::Map<_a, _b> {
        fold_1(
            Lrc::from(move |acc: Map_::Map<_a, _b>, tupledArg: Lrc<(_a, _b)>| {
                Map_::add(tupledArg.0.clone(), tupledArg.1.clone(), acc.clone())
            }),
            Map_::empty(),
            xs,
        )
    }
    pub fn ofList<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        xs: List<Lrc<(_a, _b)>>,
    ) -> Map_::Map<_a, _b> {
        fold_2(
            Lrc::from(move |acc: Map_::Map<_a, _b>, tupledArg: Lrc<(_a, _b)>| {
                Map_::add(tupledArg.0.clone(), tupledArg.1.clone(), acc.clone())
            }),
            Map_::empty(),
            xs,
        )
    }
    pub fn ofSeq<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        xs: Lrc<dyn IEnumerable_1<Lrc<(_a, _b)>>>,
    ) -> Map_::Map<_a, _b> {
        fold_3(
            Lrc::from(move |acc: Map_::Map<_a, _b>, tupledArg: Lrc<(_a, _b)>| {
                Map_::add(tupledArg.0.clone(), tupledArg.1.clone(), acc.clone())
            }),
            Map_::empty(),
            xs,
        )
    }
    #[derive(Clone, Debug, Default, Hash)]
    pub struct MapIterator_2<K: PartialOrd + Clone + 'static, V: Clone + 'static> {
        pub stack: MutCell<List<Map_::Map<K, V>>>,
        pub started: MutCell<bool>,
    }
    impl<K: PartialOrd + Clone + 'static, V: Clone + 'static> Map_::MapIterator_2<K, V> {}
    pub fn collapseLHS<K: Clone + 'static, V: Clone + 'static>(
        stack: List<Map_::Map<K, V>>,
    ) -> List<Map_::Map<K, V>> {
        let stack: Lrc<MutCell<List<Map_::Map<K, V>>>> = Lrc::from(MutCell::from(stack.clone()));
        '_collapseLHS: loop {
            break '_collapseLHS (if !isEmpty_1(stack.get()) {
                let rest: List<Map_::Map<K, V>> = tail(stack.get()).clone();
                let matchValue: Option<Lrc<Map_::MapTree_2<K, V>>> = head(stack.get()).root.clone();
                match &matchValue {
                    Some(matchValue_0_0) => {
                        let t: Lrc<Map_::MapTree_2<K, V>> = matchValue_0_0.clone();
                        if t.Height == 1i32 {
                            stack.get()
                        } else {
                            let stack_temp: List<Map_::Map<K, V>> = cons(
                                t.Left.clone(),
                                cons(
                                    Map_::mkMapTreeLeaf(t.Key.clone(), t.Value.clone()),
                                    cons(t.Right.clone(), rest),
                                ),
                            );
                            stack.set(stack_temp);
                            continue '_collapseLHS;
                        }
                    }
                    _ => {
                        let stack_temp: List<Map_::Map<K, V>> = rest;
                        stack.set(stack_temp);
                        continue '_collapseLHS;
                    }
                }
            } else {
                empty_1::<Map_::Map<K, V>>()
            });
        }
    }
    pub fn mkIterator<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        m: Map_::Map<_a, _b>,
    ) -> Lrc<Map_::MapIterator_2<_a, _b>> {
        Lrc::from(Map_::MapIterator_2::<_a, _b> {
            stack: MutCell::from(Map_::collapseLHS(singleton_1(m))),
            started: MutCell::from(false),
        })
    }
    pub fn notStarted<_a: Clone + 'static>() -> _a {
        panic!("{}", enumerationNotStarted())
    }
    pub fn alreadyFinished<_a: Clone + 'static>() -> _a {
        panic!("{}", enumerationAlreadyFinished())
    }
    pub fn unexpectedStackForCurrent<_a: Clone + 'static>() -> _a {
        panic!(
            "{}",
            string("Please report error: Map iterator, unexpected stack for current")
        )
    }
    pub fn unexpectedStackForMoveNext<_a: Clone + 'static>() -> _a {
        panic!(
            "{}",
            string("Please report error: Map iterator, unexpected stack for moveNext")
        )
    }
    pub fn current<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        i: Lrc<Map_::MapIterator_2<_a, _b>>,
    ) -> Lrc<(_a, _b)> {
        if i.started.get() {
            let matchValue: List<Map_::Map<_a, _b>> = i.stack.get().clone();
            if !isEmpty_1(matchValue.clone()) {
                if head(matchValue.clone()).root.is_some() {
                    let t: Lrc<Map_::MapTree_2<_a, _b>> =
                        getValue(head(matchValue).root.clone()).clone();
                    if t.Height == 1i32 {
                        Lrc::from((t.Key.clone(), t.Value.clone()))
                    } else {
                        Map_::unexpectedStackForCurrent()
                    }
                } else {
                    Map_::alreadyFinished()
                }
            } else {
                Map_::alreadyFinished()
            }
        } else {
            Map_::notStarted()
        }
    }
    pub fn moveNext<_a: PartialOrd + Clone + 'static, _b: Clone + 'static>(
        i: Lrc<Map_::MapIterator_2<_a, _b>>,
    ) -> bool {
        if i.started.get() {
            let matchValue: List<Map_::Map<_a, _b>> = i.stack.get().clone();
            if !isEmpty_1(matchValue.clone()) {
                if head(matchValue.clone()).root.is_some() {
                    let t: Lrc<Map_::MapTree_2<_a, _b>> =
                        getValue(head(matchValue.clone()).root.clone()).clone();
                    if t.Height == 1i32 {
                        i.stack.set(Map_::collapseLHS(tail(matchValue).clone()));
                        !isEmpty_1(i.stack.get().clone())
                    } else {
                        Map_::unexpectedStackForMoveNext()
                    }
                } else {
                    false
                }
            } else {
                false
            }
        } else {
            i.started.set(true);
            !isEmpty_1(i.stack.get().clone())
        }
    }
    pub fn toSeq<K: PartialOrd + Clone + 'static, V: Clone + 'static>(
        m: Map_::Map<K, V>,
    ) -> Lrc<dyn IEnumerable_1<Lrc<(K, V)>>> {
        delay(Lrc::from({
            let m = m.clone();
            move || {
                unfold(
                    Lrc::from(move |i: Lrc<Map_::MapIterator_2<K, V>>| {
                        if Map_::moveNext(i.clone()) {
                            Some(Lrc::from((Map_::current(i.clone()), i.clone())))
                        } else {
                            None::<Lrc<(Lrc<(K, V)>, Lrc<Map_::MapIterator_2<K, V>>)>>
                        }
                    }),
                    Map_::mkIterator(m.clone()),
                )
            }
        }))
    }
    pub fn compareTo<K: PartialOrd + Clone + 'static, V: PartialOrd + Clone + 'static>(
        m1: Map_::Map<K, V>,
        m2: Map_::Map<K, V>,
    ) -> i32 {
        compareWith(
            Lrc::from(move |e: Lrc<(K, V)>, e_1: Lrc<(K, V)>| compare(e.clone(), e_1.clone())),
            Map_::toSeq(m1),
            Map_::toSeq(m2),
        )
    }
    pub fn equals<K: PartialOrd + Clone + 'static, V: PartialOrd + Clone + 'static>(
        m1: Map_::Map<K, V>,
        m2: Map_::Map<K, V>,
    ) -> bool {
        Map_::compareTo(m1, m2) == 0i32
    }
}
